<?php
	
	class insertorupdatecategorytranslation extends WC_API_Resource
	{
		
		protected $base = '/insertorupdatecategorytranslation';
		
		public function register_routes($routes)
		{
			# GET /getcategorynsids
			
			$routes[ $this->base ] = [
				[[$this, 'get_iouct'], WC_API_Server::READABLE | WC_API_SERVER::EDITABLE | WC_API_SERVER::ACCEPT_DATA],
			];
			
			return $routes;
		}
		
		public function get_iouct()
		{
			
			global $wpdb;
			
			
			$table_name_anu = $wpdb->prefix . "In8SyncTracking";
			
			
			$parent_id = $_REQUEST["parent_id"];
			
			$core_category_id = $_REQUEST["core_category_id"];
			
			$core_category_langcode = $_REQUEST["core_category_langcode"];
			
			$translation_category_name = $_REQUEST["translation_category_name"];
			
			$translation_category_description = $_REQUEST["translation_category_description"];
			
			$translation_category_langcode = $_REQUEST["translation_category_langcode"];
			
			$category_imageid = $_REQUEST["category_imageid"];
			
			
			$parent_id = (isset($parent_id)) ? $parent_id : NULL;
			
			
			$query = "SELECT count(entity_id) as count, entity_id FROM $table_name_anu where tracking_type = 'category_translation' and related_entity_id = %d and tracking_data = '%s'";
			$sql = $wpdb->prepare($query, $core_category_id, $translation_category_langcode);
			$query = $wpdb->get_results($sql);
			
			$count = $query[0]->count;
			
			$entity_id = $query[0]->entity_id;
			
			$has_tracking_entry = $count > 0;
			
			
			if ($has_tracking_entry == FALSE) {
				
				// if translation category does not exist, insert it
				
				$result = wp_insert_term($translation_category_name, "product_cat", [
						"parent"      => $parent_id,
						"taxonomy"    => "product_cat",
						"description" => $translation_category_description,
					]
				);
			} else {
				
				// if translation category_id exists, update the category info
				
				$result = wp_update_term($translation_category_name, "product_cat", [
						"parent"      => $parent_id,
						"taxonomy"    => "product_cat",
						"description" => $translation_category_description,
					]
				);
			}
			
			
			$returnobj = new stdClass();
			
			
			if (is_wp_error($result)) {
				
				// if error occurred and category exists already at this level, get existing woocomm_category_id (term_id)
				
				$returnobj->woocomm_category_id = ($result->error_data["term_exists"]);
			} else {
				
				// else get new woocomm_category_id (term_id)
				
				$returnobj->woocomm_category_id = $result["term_id"];
			}
			
			
			if ($returnobj->woocomm_category_id == NULL or $returnobj->woocomm_category_id <= 0) {
				
				$returnobj->woocomm_category_id = $entity_id;
			}
			
			
			// assign new (or updated) translation category id
			
			$translation_category_id = $returnobj->woocomm_category_id;
			
			
			// insert new tracking entry for translation if needed
			
			if ($has_tracking_entry == FALSE) {
				
				$wpdb->insert(
					$table_name_anu, [
					'tracking_type'              => 'category_translation',
					'entity_id'                  => $translation_category_id,
					'entity_description'         => 'translated category',
					'related_entity_id'          => $core_category_id,
					'related_entity_description' => 'source category',
					'tracking_data'              => $translation_category_langcode,
					'tracking_data_description'  => $translation_category_langcode . ' translation',
				], [
						'%s',
						'%d',
						'%s',
						'%d',
						'%s',
						'%s',
						'%s',
					]
				);
			}
			
			
			$translations_table_name = $wpdb->prefix . 'icl_translations';
			
			
			$query = "SELECT trid FROM " . $translations_table_name . " where element_type = 'tax_product_cat' and element_id = %d and language_code = '%s'";
			$sql = $wpdb->prepare($query, $core_category_id, $core_category_langcode);
			$query = $wpdb->get_results($sql);
			
			$trid = $query[0]->trid;
			
			
			$query = "SELECT count(trid) as count FROM " . $translations_table_name . " where element_type = 'tax_product_cat' and element_id = %d and trid = %d";
			
			$sql = $wpdb->prepare($query, $translation_category_id, $trid);
			
			$query = $wpdb->get_results($sql);
			
			$count = $query[0]->count;
			
			$has_translation_entry = $count > 0;
			
			
			// insert new LINKING entry for translation if needed
			
			if ($has_translation_entry == FALSE) {
				
				$wpdb->replace(
					$translations_table_name, [
					'element_type'         => 'tax_product_cat',
					'element_id'           => $translation_category_id,
					'trid'                 => $trid,
					'language_code'        => $translation_category_langcode,
					'source_language_code' => $core_category_langcode,
				], [
						'%s',
						'%d',
						'%d',
						'%s',
						'%s',
					]
				);
			}
			
			
			$term_id = $translation_category_id;
			
			
			if ($category_imageid != 0) {
				
				add_woocommerce_term_meta($term_id, 'thumbnail_id', $category_imageid, TRUE);
			}
			
			
			echo json_encode($returnobj);
			
			exit;
		}
		
	}
