<?php

class IN8_Process_Product_Map {

    public static function processField($product, $type, $data, $ns) {

        $type = explode(',', $type);
        $field = $type[1];
        $type = $type[0];

        if (method_exists('IN8_Process_Product_Map', $type)) {
            $data = call_user_func_array(['IN8_Process_Product_Map', $type], [$product, $field, $data, $ns]);
        } else {
            $data = call_user_func_array(['IN8_Process_Product_Map', 'post'], [$product, $field, $data, $ns]);
        }
        return $data;
    }

    public static function post($product, $field, $data, $ns) {
        /* @var WC_Product $product */
        if (method_exists('IN8_Process_Product_Map', 'post_field_' . $field)) {
            $data = call_user_func_array(['IN8_Process_Product_Map', 'post_field_' . $field], [$product, $field, $data, $ns]);
        } else {
            $data[$ns] = $product->post->{$field};
        }
        return $data;
    }

    public static function meta($product, $field, $data, $ns) {
        /* @var WC_Product $product */
        if (method_exists('IN8_Process_Product_Map', 'meta_field_' . $field)) {
            $data = call_user_func_array(['IN8_Process_Product_Map', 'meta_field_' . $field], [$product, $field, $data, $ns]);
        } else {
            $data[$ns] = get_post_meta($product->id, $field, true);
        }
        return $data;
    }
    
    public static function fixed($product, $field, $data, $ns) {
        
        $data[$ns] = $field;
        
        return $data;
    }

    public static function meta_field__pricing_rules($product, $field, $data, $ns) {
        /* @var WC_Product $product */
        $dynamic_rules = get_post_meta($product->id, '_pricing_rules', true);

        $setsCount = 1;
        $level = 2;
        foreach ($dynamic_rules as $set) {
            $quantityGroups = 1;
            foreach ($set['rules'] as $rule) {
                $data['price1quantity' . $quantityGroups] = $rule['from'];

                $data['pricingMatrix'][] = [
                    'priceId' => $setsCount,
                    'quantityLevel' => $quantityGroups,
                    'price' => floatval($rule['amount']),
                    'priceLevel' => $level,
                ];
                $quantityGroups ++;
            }
            $setsCount ++;
        }
        asort($data);

        return $data;
    }
    public static function meta_field__crosssell_ids($product, $field, $data, $ns) {
        /* @var WC_Product $product */
	    $cross_sell_products = get_post_meta($product->get_id(), '_crosssell_ids', true);
	    if( !empty($cross_sell_products) ){
		    $cross_sell_products_ns = [];
		    foreach($cross_sell_products as $product_id){
			    $ns_id = get_post_meta($product_id, 'internalid', true);
			    if( !empty($ns_id) ){
				    $cross_sell_products_ns[] = ['presentationitem' => $ns_id.' INVTITEM'];
			    }
		    }
		    if( !empty($cross_sell_products_ns) ){
			    $data['presentationitem'] = $cross_sell_products_ns;
		    }
	    }

        return $data;
    }

    // end of class
}

$IN8_Process_Product_Map = new IN8_Process_Product_Map();
